<template>
  <div :class="{ 'is-loading': isShowLoader }">
    <SectionHeading
      :task="task"
      :is-show-loader="isShowLoader"
      :header-sections="headerSections"
    />

    <SectionTab
      v-for="(group, i) in itemsGroups"
      :key="i"
      :title="group.requisiteGroupTitle"
    >
      <div class="task-monitor-gutter">
        <div class="form-row">
          <div
            v-for="(field, index) in group.fields"
            :key="index"
            class="form-full-block"
          >
            <!-- <ObSelector
                    v-model="formData[field.fieldUuid]"
                    @input="onSelectChange(field.fieldUuid)"
                    :remote-opt="{
                      method: getDictionaryList,
                      arguments: { dictionary: field.settings.dict_table_name }
                    }"
                    class="itemSave"
                    v-if="field.dataType === 'CHECKLIST_LIST' || field.dataType === 'CHECKLIST'"
                    :label="field.title"
                    :isDropdown="field.dataType === 'CHECKLIST_LIST'"
                    :isAutoComplete="true"
                    :displayExp="field.settings.dict_table_name === 'okved' ? 'name': 'title'"
                    :data-uuid="field.fieldUuid"
                    :data-dict="field.settings.dict_table_name"
                    :data-type="field.dataType"
                    :placeholder="(field.settings && field.settings.masks && field.settings.masks.length > 0) ? field.settings.masks[0] : field.title"
                    :disabled="!isNewTask"
            /> -->

            <!-- CRUTCH FOR DEMO OF 03.08.2020 https://oboz.myjetbrains.com/youtrack/issue/SB_UAT-445
            !*** Delete crutch block and uncomment code above to restore original logic
            -->

            <ObSelector
              v-if="(field.dataType === 'CHECKLIST_LIST' || field.dataType === 'CHECKLIST') && field.code !== 'vehicle_categories'"
              v-model="formData[field.fieldUuid]"
              @input="onSelectChange(field.fieldUuid)"
              :remote-opt="{
                method: getDictionaryList,
                arguments: { dictionary: field.settings.dict_table_name }
              }"
              :label="field.title"
              :isDropdown="field.dataType === 'CHECKLIST_LIST'"
              :isAutoComplete="true"
              :displayExp="field.settings.dict_table_name === 'okved' ? 'name': 'title'"
              :data-uuid="field.fieldUuid"
              :data-dict="field.settings.dict_table_name"
              :data-type="field.dataType"
              :placeholder="getFieldPlaceholder(field)"
              :disabled="!isNewTask"
              class="itemSave"
            />

            <ObSelector
              v-if="(field.dataType === 'CHECKLIST_LIST' || field.dataType === 'CHECKLIST') && field.code === 'vehicle_categories'"
              v-model="formData[field.fieldUuid]"
              @input="onSelectChange(field.fieldUuid)"
              :items="field.values[0].data.valuesTitled.values"
              :label="field.title"
              :isDropdown="field.dataType === 'CHECKLIST_LIST'"
              :isAutoComplete="true"
              :data-uuid="field.fieldUuid"
              :data-type="field.dataType"
              :placeholder="getFieldPlaceholder(field)"
              :disabled="!isNewTask"
              class="itemSave"
            />

            <!-- END OF CRUTCH FOR DEMO OF 03.08.2020 https://oboz.myjetbrains.com/youtrack/issue/SB_UAT-445 -->

            <ObCheckbox
              v-if="field.dataType === 'BOOLEAN'"
              v-model="formData[field.fieldUuid]"
              :label="getCheckboxLabel(field.code, field.title)"
              :data-uuid="field.fieldUuid"
              :data-type="field.dataType"
              :placeholder="getFieldPlaceholder(field)"
              :disabled="!isNewTask"
              class="itemSave"
            />

            <ObInput
              v-if="field.dataType === 'NUMERIC' || field.dataType === 'TEXT'"
              v-model="formData[field.fieldUuid]"
              :is-valid="errors[field.fieldUuid] ? false : null"
              :validation-message="errors[field.fieldUuid]"
              :label="field.title"
              :type="field.dataType === 'NUMERIC' ? 'number' : 'text'"
              :data-uuid="field.fieldUuid"
              :data-type="field.dataType"
              :placeholder="getFieldPlaceholder(field)"
              :disabled="!isNewTask"
              class="itemSave"
              @input="inputHandler(field)"
            />

            <ObDatepicker
              v-if="field.dataType === 'DATE'"
              v-model="formData[field.fieldUuid]"
              :label="field.title"
              :data-uuid="field.fieldUuid"
              :data-type="field.dataType"
              :placeholder="getFieldPlaceholder(field)"
              :disabled="!isNewTask"
              class="itemSave"
              lang="ru"
            />
          </div>
        </div>
      </div>
    </SectionTab>

    <div
      v-if="links && links.length"
      class="form-tab"
    >
      <div class="form-tab-title" @click="onGroupClick(uploader)">
        <i :class="`icon chevron-${uploader.isHide ? 'up' : 'down'}`" />

        Загрузка файлов
      </div>

      <div class="form-tab-content">
        <div class="task-monitor-gutter">
          <div class="form-row form-halfed-wrapper">
            <div
              v-for="link in links"
              :key="link.docTypeUuid"
              class="form-halfed-block"
            >
              <ObUploader
                :label="link.docTypeTitle"
                :is-read-only="!isNewTask"
                icon="excel"
                @change="onUploadFiles($event, link.docTypeUuid)"
              />
            </div>
          </div>
        </div>
      </div>
    </div>

    <div
      v-if="isNewTask"
      class="task-monitor-gutter task-monitor-buttons-container"
    >
      <ObButton
        :disabled="isSubmitDisabled"
        @click="onSave"
        label="Подтвердить"
      />
    </div>
  </div>
</template>

<script>
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObDatepicker from 'common-components/src/obComponents/obDatePickerConstructor'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import ObSelector from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObButton from "common-components/src/obComponents/obButton"
  import api from '@/api'
  import { uuid } from 'vue-uuid'
  import moment from 'moment'
  import { groupsFieldsSort } from '@/helpers/fields'
  import SectionMixin from './SectionMixin'

  export default {
    name: 'sectionConstructor',
    mixins: [
      SectionMixin
    ],
    components: {
      ObInput,
      ObDatepicker,
      ObUploader,
      ObSelector,
      ObCheckbox,
      ObButton
    },
    data () {
      return {
        itemsGroups: [],
        resourceUuid: '',
        domainUuid: '',
        links: [],
        uploader: {
          files: [],
          isHide: false
        },
        errors: {},
        formData: {},
        driverPhoneCodes: [ 'phone', 'dispatcher_phone' ],
        driverPhoneLabelCodes: [ 'phone_call', 'dispatcher_phone_call' ],
        driverInfo: {}
      }
    },
    watch: {
      task () {
        this.itemsGroups = []

        if (Object.keys(this.task).length === 0) {
          return
        }

        this.getFields()
      }
    },
    computed: {
      isSubmitDisabled () {
        return Object.values(this.errors).some(value => Boolean(value)) || this.isEmptyFields || this.isEmptyFiles
      },
      isEmptyFields () {
        return Object.values(this.formData).some(value => value === undefined || value === '' || value === null || !!(Array.isArray(value) && !value.length))
      },
      isEmptyFiles () {
        if (!this.links || !this.links.length) {
          return false
        }

        return this.links.length !== this.uploader.files.length
      }
    },
    created () {
      this.getFields()
    },
    methods: {
      async getFields () {
        this.formData = {}
        this.errors = {}
        this.itemsGroups = []
        this.isLoading = true

        if (this.isParticipant) {
          try {
            const fields = await api.taskMonitor.getParticipantTaskFields(this.task.uuid)

            this.domainUuid = fields.data.domainUuid
            this.participantUuid = fields.data.participantUuid

            this.updateData(fields.data)
          } catch (e) {
            console.error(e)

            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка загрузки данных'
            })
          }
        } else {
          try {
            const { data } = await api.taskMonitor.getResourceTaskFields(this.task.uuid)

            this.resourceUuid = (data.resourceInfoDto && data.resourceInfoDto.uuid) ? data.resourceInfoDto.uuid : ''
            this.participantUuid = this.task.card_uuid
            this.domainUuid = data.uuid

            // TODO: using 'species_code' instead of 'species_title'
            if (data.resourceInfoDto?.species_title === 'Водитель') {
              const resourceInfo = await api.resources.getParticipantDetail({ uuid: this.resourceUuid })

              resourceInfo.domains[0].groups.some((group) => {
                let isFound = false

                group.fields.forEach((field) => {
                  if (this.driverPhoneCodes.includes(field.code)) {
                    this.driverInfo[field.code] = field.values[0]?.data?.value

                    isFound = true
                  }
                })

                return isFound
              })
            }

            this.updateData(data)
          } catch (e) {
            console.error(e)

            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка загрузки данных'
            })
          }
        }

        this.isLoading = false
      },
      updateData (item) {
        this.links = item.links
        this.itemsGroups = []

        let groups = groupsFieldsSort(item.groups)

        this.itemsGroups = groups.map((group) => {
          if (group.fields) {
            group.fields.forEach((field) => {
              // Если обязательно к заполнению, то добавляем в formData этот филд (isRequired пока нет)
              // if (!this.formData[field.fieldUuid] && field.isRequired) {
              if (!this.formData[field.fieldUuid] && field.dataType !== 'CHECKLIST_LIST') {
                let value
                switch (field.dataType) {
                  case 'NUMERIC':
                  case 'TEXT':
                  case 'DATE':
                  case 'CHECKLIST':
                    value = ''
                    break
                  // case 'CHECKLIST_LIST':
                  //   value = []
                  //   break
                  case 'BOOLEAN':
                    value = false
                    break
                }
                this.$set(this.formData, field.fieldUuid, value)
                this.$set(this.errors, field.fieldUuid, null)
              }
            })
          }

          return {
            ...group,
            _hidden: false
          }
        })
      },
      onUploadFiles (files, docTypeUuid) {
        if (files && files.length) {
          const f = {
            ...files[0],
            docTypeUuid,
            fileUuid: uuid.v4()
          }

          const index = this.uploader.files.findIndex(file => file.docTypeUuid === docTypeUuid)

          if (index >= 0) {
            this.uploader.files[index] = f
          } else {
            this.uploader.files.push(f)
          }
        } else {
          this.uploader.files = this.uploader.files.filter(file => file.uuid !== uuid)
        }
      },
      getFieldPlaceholder (field) {
        return field.settings?.masks?.[0] || field.title
      },
      async onSave () {
        this.isLoading = true
        let notificationId = new Date().getTime() + 'save'
        this.$notification({ type: 'system_notification_in_load', message: 'Сохранение', id: notificationId })

        try {
             // >>> Uploading files
          try {
            const uploadRequest = item => {
              return new Promise((resolve, reject) => {
                const jsonData = {
                  filename: item.file.name,
                  participant_uuid: this.participantUuid,
                  domain_uuid: this.domainUuid,
                  is_personal_info: true
                }

                const form = new FormData()

                form.append('jsonData', JSON.stringify(jsonData))
                form.append('file', item.file)

                api.taskMonitor.postTaskFile(item.fileUuid, form).then(() => {
                  resolve()
                }).catch(e => {
                  console.log(e)

                  reject(e)
                })
              })
            }
            const delayedLog = async (item) => {
              await uploadRequest(item)
            }
            const uploadFiles = async (array) => {
              const promises = array.map(delayedLog)

              await Promise.all(promises)
            }
            await uploadFiles(this.uploader.files)

          } catch (e) {
            throw 'Файлы не сохранены'
          }

          // >>> Posting task payload
          try {
            let itemsFields = []
            let arr = document.getElementsByClassName('itemSave')

            for (let i of arr) {
              let typeItem = i.attributes['data-type'].value
              let valItem = ''
              let keyValue = 'value'

              switch (typeItem) {
                case 'TEXT':
                  valItem = i.querySelector('input').value
                  break
                case 'NUMERIC':
                  valItem = Number(valItem = i.querySelector('input').value)
                  break
                case 'DATE':
                  valItem = i.querySelector('input') ? i.querySelector('input').value : null
                  valItem = valItem ? moment(valItem, 'DD.MM.YYYY').format('YYYY-MM-DD') : null
                  break
                case 'CHECKLIST':
                  keyValue = 'value'
                  valItem = i.getAttribute('data-selected-value')
                  break
                case 'CHECKLIST_LIST':
                  keyValue = 'values'
                  valItem = i.getAttribute('data-selected-value').split(', ').map(el => el.trim()).filter(Boolean)
                  break
                case 'BOOLEAN':
                  valItem = i.querySelector('input').checked
                  break
              }

              const item = {
                uuid: i.attributes['data-uuid'].value,
                fieldValue: {
                  uuid: uuid.v4(),
                  data: {
                    valueType: typeItem,
                    [keyValue]: valItem
                  },
                  isPriority: false
                }
              }

              itemsFields.push(item)
            }

            const payload = {
              [this.isParticipant ? 'participantUuid' : 'resourceUuid']: this.isParticipant ? this.task.card_uuid : this.resourceUuid,
              domainUuid: this.domainUuid,
              fields: itemsFields,
              links: this.uploader.files.map(({docTypeUuid, fileUuid}) => {
                return {
                  docTypeUuid,
                  docs: [{
                    fileUuid,
                    uuid: uuid.v4()
                  }]
                }
              })
            }
            const response = await api.taskMonitor[`post${this.isParticipant ? 'Participant' : 'Resource'}TaskFields`](payload)
            if (response && response.error) throw `Ошибка при сохранении данных: ${response.error}`

          } catch (e) {
            throw e
          }

          // >>> Archiving task
          try {
            const res = await api.taskMonitor.postTaskExecuted(this.task.uuid, this.userUuid)
            if (res && res.error) throw `Ошибка архивации задачи: ${res.error}`

          } catch (e) {
            throw e
          }

          this.onTaskSuccess()
          this.onClose()

        } catch(e) {
          console.error(e)

          this.$notification({ type: 'system_notification_error', message: e })
        }

        this.$notification({ event: 'close', id: notificationId })
        this.isLoading = false
      },
      async getDictionaryList ({ dictionary, page, size, query, sort }) {
        let response

        try {
          response = await api.taskMonitor.getOptions(dictionary, page, size, query, sort)
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }

        return response
      },
      inputHandler (field) {
        let title = field.title
        let input = document.querySelector('[data-uuid="' + field.fieldUuid + '"] input')

        if (!input) {
          return null
        }

        let value = input.value
        let error

        switch (title) {
          case 'ИНН':
            error = value.length !== 10 && value.length !== 12 ? 'Некорректный ИНН' : null
            break
          case 'КПП':
            error = value.length !== 9 ? 'Некорректный КПП' : null
            break
          case 'БИК банка':
            error = value.length !== 9 ? 'Некорректный БИК' : null
            break
          case 'Телефон':
            error = value.length !== 11 ? 'Некорректный телефон' : null
            break
          case 'Телефон Генерального директора':
            error = value.length !== 11 ? 'Некорректный телефон' : null
            break
          case '№ основного расчетного счета':
            error = value.length !== 20 ? 'Некорректный номер счета' : null
            break
          default:
            error = null
        }

        this.errors[field.fieldUuid] = error
      },
      onSelectChange(fieldUuid) {
        // Delete uuid of the multiselector from formData to avoid check for empty field for multiselector
        if (Array.isArray(this.formData[fieldUuid]) && !this.formData[fieldUuid].length) delete this.formData[fieldUuid]
      },
      getCheckboxLabel (code, title) {
        if (this.driverPhoneLabelCodes.includes(code)) {
          let phone = this.driverInfo[code.replace('_call', '')]

          if (phone) {
            // Adding whitespaces to format phone
            phone = phone.replace(/(\d{3})(\d{3})(\d{4})/, '$1 $2 $3')

            return `${title} ${phone}`
          }
        }

        return title
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';

  .task-monitor-gutter {
    padding: 0 40px;
  }

  .task-monitor-buttons-container {
    display: flex;
    justify-content: flex-end;
    margin-top: 40px;
  }

  .form-tab.inactive {
    .form-tab-content {
      display: none;
    }

    &:last-of-type .form-tab-title {
      border-bottom: 1px solid $lavender;
    }
  }

  .form-halfed-wrapper {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;
  }

  .form-halfed-block {
    width: calc(50% - 10px);
    margin-bottom: 20px;
  }

  .form-full-block {
    width: 100%;
    margin-bottom: 20px;
  }
</style>
